<?php
/**
 * @copyright (c) Kufer Software GmbH, Loisachstrasse 4, D-84453 Mühldorf
 */

namespace Kufer\KuferTools\Veranstalter\KursVorschlag\KursVorschlag;

class KursVorschlagFormularUseCase extends \Kufer\KuferTools\Basis\KursPlanung\KursVorschlag\KursVorschlagFormularUseCase
{
  public static function getToolSectionId()
  {
    return 616;
  }

  public static function getToolId()
  {
    return \ToolsAPI::TOOL_KURSVORSCHLAG_VA;
  }

  protected function isKursKopieAllowed()
  {
    return $this->isRechtAllowed('616.0.1');
  }

  protected function hideBackButton()
  {
    return true;
  }

  protected function getKursplanung()
  {
    $kursplanung = parent::getKursplanung();
    if (!trim($this->request->kopiertVon) == '') {
      $dbwork = new \DBWorkKurse(1, true);
      $kurs = $dbwork->getKurs($this->request->kopiertVon);
      $hauptdozent = $kurs->getVarValue('hauptdozent');
      if (is_numeric($hauptdozent->id) && $hauptdozent->id > 0) {
        $kursplanung->dozNr = $hauptdozent->id;
      }
    }

    return $kursplanung;
  }

  protected function setDozentenToKursplanung($pKursplanung, $pKnr)
  {
    if (\DBWorkBASysSettings::isSalzburgBildungswerk()) {
      $dbwDozKurs = new \DBWorkDozentenHonorar(1, true);
      $dozKurs = $dbwDozKurs->getHonorarebyKNR($pKnr);

      $dozenten = array();
      foreach ($dozKurs as $dk) {
        $istVKurs = \Kufer\KuferTools\Veranstalter\Utils\VeranstalterUtils::isVKurs($pKnr);
        if ($dk->typ == 'D') {
          $dozenten[] = \KursplanungDozenten::loadFromDozentHonorar($dk, $istVKurs);
        } elseif ($istVKurs && $dk->typ == 'I') {
          $dozenten[] = \KursplanungDozenten::loadFromDozentHonorar($dk);
        }
      }
      $pKursplanung->dozenten = $dozenten;
    }

    return $pKursplanung;
  }

  protected function belegeKursplanungVor($pKursplanung, $isKursKopie = false)
  {
    $kursplanung = parent::belegeKursplanungVor($pKursplanung, $isKursKopie);
    if (\DBWorkBASysSettings::isSalzburgBildungswerk()) {
      $kursplanung->internetaktiv = true;
      $kursplanung->presse_weitergabe = true;
      $kursplanung->eduard_weitergabe = true;
    }

    return $kursplanung;
  }
}